// DesfireTestDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "DesfireTest.h"
#include "DesfireTestDlg.h"

#include "PortDlg.h"
#include "label.h"
#include "BitmapStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib, "version.lib")

CString GetProgVersion ()
{
  char * abData;
  char String[255];
  
  CString Version;

  DWORD  handle = NULL;
  UINT   wSize = 0;
  DWORD  dwMax = 0;
  LPSTR  lpBuffer = NULL;
  
  char ExeName[_MAX_PATH];
  ::GetModuleFileName(NULL,ExeName,_MAX_PATH);

  dwMax = GetFileVersionInfoSize(ExeName, &handle);
  
  if (dwMax == 0)
  {
    Version = "1.xx";
    return Version;
  }
  
  if (dwMax > 32000)
  {
    Version = "1.xx";
    return Version;
  }
  
  abData = new char[dwMax+10];
  
  memset (abData,0,(WORD)(dwMax+10));
  
  if (GetFileVersionInfo(ExeName, handle, dwMax, abData))
  {
    strcpy (String,"\\StringFileInfo\\040704b0\\ProductVersion");
    if (VerQueryValue(abData, String, (LPVOID *)&lpBuffer, &wSize))
    {
      if ((lpBuffer) && (wSize!=0) && (strlen(lpBuffer) < 20))
        Version = lpBuffer;
    }
  }
  
  if (Version.IsEmpty())
    Version = "1.xx";
      
  delete []abData;
  
  return Version;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CBitmapStatic	m_GisBitmap;
  CLabel m_Email;
  CLabel m_URL;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_GIS_LOGO, m_GisBitmap);
	DDX_Control(pDX, IDC_EMAIL, m_Email);
	DDX_Control(pDX, IDC_URL, m_URL);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

  // URL und Email als Link darstellen (Blau, unterstrichen)
  LOGFONT lf;
  GetFont()->GetLogFont(&lf);
  lf.lfUnderline = TRUE;
  m_Email.SetFont(&lf);
  m_Email.SetLink(TRUE);
  m_Email.SetTextColor(RGB(  0,  0,255));
  m_Email.SetLinkCursor(::LoadCursor(NULL,MAKEINTRESOURCE(32649)));
  m_URL  .SetFont(&lf);
  m_URL  .SetLink(TRUE);
  m_URL  .SetTextColor(RGB(  0,  0,255));
  m_URL  .SetLinkCursor(::LoadCursor(NULL,MAKEINTRESOURCE(32649)));

  m_GisBitmap.SetTransparent();

  // richtige Versionsnummer in Text eintragen
  CString text;
  GetDlgItemText(IDC_VERSION,text);
  
  text += " ";
  text += GetProgVersion();
  SetDlgItemText (IDC_VERSION,text);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/////////////////////////////////////////////////////////////////////////////
// CDesfireTestDlg Dialogfeld

CDesfireTestDlg::CDesfireTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDesfireTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDesfireTestDlg)
	m_strRequest = _T("");
	m_strSelect = _T("");
	m_strUID = _T("");
	m_DRI = 0;
	m_DSI = 0;
	m_ATS = _T("");
	m_CID = 0;
	m_TCLSend = _T("");
	m_TCLReceive = _T("");
	//}}AFX_DATA_INIT

	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDesfireTestDlg::ClearContents()
{
	m_strRequest = _T("");
	m_strSelect = _T("");
	m_strUID = _T("");

  UpdateData(FALSE);
}

void CDesfireTestDlg::SetButtonState()
{
  BOOL bActive = (m_hPort != 0)?TRUE:FALSE;

	GetDlgItem(IDC_REQA         )->EnableWindow(bActive);
	GetDlgItem(IDC_SELECT       )->EnableWindow(bActive);
	GetDlgItem(IDC_HALT         )->EnableWindow(bActive);
  GetDlgItem(IDC_RATS         )->EnableWindow(bActive);
  GetDlgItem(IDC_PPS          )->EnableWindow(bActive);
}

void CDesfireTestDlg::ShowMessage(LPCTSTR Message,int FehlerNummer /*= 0*/)
{
  if (FehlerNummer != 0)
  {
    CString str;
    if ((FehlerNummer > 128) && (FehlerNummer < 256))
      FehlerNummer = (char)FehlerNummer;
    str.Format("%s <%d>",Message,FehlerNummer);
    //AfxMessageBox(str);
    m_Status.SetWindowText(str);
  }
  else
  {
    //AfxMessageBox(Message);
    m_Status.SetWindowText(Message);
  }
}

void CDesfireTestDlg::ShowMessage(int nMessageID,int FehlerNummer /*= 0*/)
{
  CString str;
  str.LoadString(nMessageID);
  ShowMessage(str,FehlerNummer);
}


void CDesfireTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDesfireTestDlg)
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Text(pDX, IDC_REQA_ANSWER, m_strRequest);
	DDX_Text(pDX, IDC_SELECT_ANSWER, m_strSelect);
	DDX_Text(pDX, IDC_UID, m_strUID);
	DDX_Radio(pDX, IDC_DRI_106, m_DRI);
	DDX_Radio(pDX, IDC_DSI_106, m_DSI);
	DDX_Text(pDX, IDC_ATS, m_ATS);
	DDX_Text(pDX, IDC_CID, m_CID);
	DDV_MinMaxInt(pDX, m_CID, 0, 14);
	DDX_Text(pDX, IDC_TCL_SEND, m_TCLSend);
	DDX_Text(pDX, IDC_TCL_RECEIVE, m_TCLReceive);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDesfireTestDlg, CDialog)
	//{{AFX_MSG_MAP(CDesfireTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SUCHEN, OnSuchen)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_REQA, OnRequest)
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	ON_BN_CLICKED(IDC_HALT, OnHalt)
	ON_BN_CLICKED(IDC_UID_ZYKLISCH, OnUIDZyklisch)
	ON_BN_CLICKED(IDC_PPS, OnPPS)
	ON_BN_CLICKED(IDC_RATS, OnRats)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_COMMON_REQUEST, OnCommonRequest)
	ON_BN_CLICKED(IDC_CARD_ID, OnCardId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDesfireTestDlg Nachrichten-Handler

BOOL CDesfireTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
  CPortDlg dlgPort;

  CString strName = dlgPort.GetName();
  int Baudrate    = dlgPort.GetBaudrate();
	int Timeout     = dlgPort.GetTimeout();

  if (strName.IsEmpty() || ((m_hPort = TSHRW_OpenPort(strName,Baudrate,Timeout)) < 0))
  {
    // Kein Zugriff auf dieses Gert
    // Nun Gert suchen
    m_hPort = 0;
    SetButtonState();
    OnSuchen();
  }
  else
  { 
    SetButtonState();
    if (m_hPort)
    {
      BYTE Version [4];
      if (TSHRW_DeviceVersion(m_hPort,Version,4) == 4)
      {
        CString strVersion;
        strVersion.Format("Gerteversion: %c%c%c%c",Version[0],Version[1],Version[2],Version[3]);
        ShowMessage(strVersion);
      }
      TSHRW_SetReaderMode(m_hPort,0);
    }
  }

  CenterWindow();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CDesfireTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CDesfireTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CDesfireTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDesfireTestDlg::OnSuchen() 
{
  if (m_hPort > 0)
  {
    //TSHRW_SetMode(m_hPort,MODE_POWERUP_DEFAULT,0,0,0,0);
    TRACE (CTime::GetCurrentTime().Format("[%H:%M:%S] ") + " vor Close in Suchen\n");
    TSHRW_SetReaderMode(m_hPort,2);
    TSHRW_ClosePort(m_hPort);
    TRACE (CTime::GetCurrentTime().Format("[%H:%M:%S] ") + " nach Close in Suchen\n");
    m_hPort = 0;
  }

  while (m_hPort == 0)
  {
	  CPortDlg dlgPort;
    if (dlgPort.DoModal() == IDOK)
    {
      CString strName = dlgPort.GetName();
      int Baudrate    = dlgPort.GetBaudrate();
	    int Timeout     = dlgPort.GetTimeout();
      if(!strName.IsEmpty())
      {
        if((m_hPort = TSHRW_OpenPort(strName,Baudrate,Timeout)) < 0)
        {
          ShowMessage(IDS_OPEN_ERROR);
          m_hPort = 0;
        }
      }
    }
    else
      break;
  }

  if (m_hPort == 0)
    PostMessage(WM_QUIT);
  
  if (m_hPort)
  {
    BYTE Version [4];
    if (TSHRW_DeviceVersion(m_hPort,Version,4) == 4)
    {
      CString strVersion;
      strVersion.Format("Gerteversion: %c%c%c%c",Version[0],Version[1],Version[2],Version[3]);
      ShowMessage(strVersion);
    }
    TSHRW_SetReaderMode(m_hPort,0);
  }
  SetButtonState();
	ClearContents();
}

void CDesfireTestDlg::OnDestroy() 
{
	CDialog::OnDestroy();

  if (m_hPort > 0)
  {
    TSHRW_SetReaderMode(m_hPort,2);
    TSHRW_ClosePort(m_hPort);
    m_hPort = 0;
  }
}

void CDesfireTestDlg::OnReset() 
{
  if (TSHRW_SetRF(m_hPort,0) < 0)
  {
    ShowMessage("SetRF(0) Error",TSHRW_GetLastError(m_hPort));
  }
  else
  {
    Sleep(50);
    if (TSHRW_SetRF(m_hPort,1) < 0)
    {
      ShowMessage("SetRF(1) Error",TSHRW_GetLastError(m_hPort));
    }
    else
    {
      ShowMessage("");
    }
  }
}

void CDesfireTestDlg::OnRequest() 
{
	if (!m_hPort)
    return;

  UpdateData(TRUE);
  m_strRequest.Empty();
  UpdateData(FALSE);

  WORD ATQA;
  if (TSHRW_Mifare_Request(m_hPort,&ATQA) < 0)
  {
    m_strRequest.Format("Error %d",TSHRW_GetLastError(m_hPort));
    ShowMessage(m_strRequest);
  }
  else
  {
    //Hex2String(m_strRequest,ATQA,2);
    m_strRequest.Format("%04X",ATQA);
    ShowMessage("");
  }
  UpdateData(FALSE);
}

void MessageLoop()
{
  MSG msg;
  int bRet;

  while ( (bRet = PeekMessage( &msg, NULL, 0, 0 ,PM_REMOVE)) != 0)
  { 
    if (bRet == -1)
    {
      // handle the error and possibly exit
    }
    else
    {
      TranslateMessage(&msg); 
      DispatchMessage(&msg); 
    }
  } 
}

void CDesfireTestDlg::OnUIDZyklisch() 
{
	if (!m_hPort)
    return;

  if (!IsDlgButtonChecked(IDC_UID_ZYKLISCH))
    return;

  UpdateData(TRUE);
  m_strRequest.Empty();
  ShowMessage("");
  GetDlgItem(IDCANCEL)->EnableWindow(FALSE);
  UpdateData(FALSE);

  do
  {
    m_strRequest.Empty();
    m_strUID.Empty();
    m_strSelect.Empty();

    UpdateData(FALSE);

    int Retry = 0;
    bool bOk = true;
    WORD ATQA;
    while (TSHRW_Mifare_Request(m_hPort,&ATQA) < 0)
    {
      if (Retry++ > 3)
      {
        //m_strRequest.Format("Error %d",TSHRW_GetLastError(m_hPort));
        //ShowMessage(m_strRequest);
        bOk = false;
        break;
      }
    }
    if (bOk)
    {
      m_strRequest.Format("%04X",ATQA);
  
      UpdateData(FALSE);
      Sleep(50);
      UpdateData(TRUE);

      BYTE UID[20];
      int len;
      BYTE Type;

      if ((len = TSHRW_Mifare_Select(m_hPort,UID,10,&Type)) < 0)
      {
        m_strUID.Format("Error %d",TSHRW_GetLastError(m_hPort));
        ShowMessage(m_strUID);
      }
      else
      {
        Hex2String(m_strUID,UID,len);
        m_strSelect = Byte2String(Type);
      }
    }
    UpdateData(FALSE);
    UpdateWindow();
    MessageLoop();
  }
  while (IsDlgButtonChecked(IDC_UID_ZYKLISCH));

  GetDlgItem(IDCANCEL)->EnableWindow(TRUE);
  UpdateData(FALSE);
}

void CDesfireTestDlg::OnSelect() 
{
	if (!m_hPort)
    return;

  UpdateData(TRUE);
  m_strUID.Empty();
  m_strSelect.Empty();

  UpdateData(FALSE);
  UpdateData(TRUE);

  BYTE UID[20];
  int len;
  BYTE Type;

  if ((len = TSHRW_Mifare_Select(m_hPort,UID,10,&Type)) < 0)
  {
    m_strUID.Format("Error %d",TSHRW_GetLastError(m_hPort));
    ShowMessage(m_strUID);
  }
  else
  {
    Hex2String(m_strUID,UID,len);
    m_strSelect = Byte2String(Type);
    ShowMessage("");
  }

  UpdateData(FALSE);
}

void CDesfireTestDlg::OnHalt() 
{
	if (!m_hPort)
    return;

  if ((TSHRW_Mifare_Halt(m_hPort)) < 0)
  {
    ShowMessage("MifareHalt Error",TSHRW_GetLastError(m_hPort));
  }
}

void CDesfireTestDlg::OnOK() 
{
  if (IsDlgButtonChecked(IDC_UID_ZYKLISCH))
    return;
  
  int nID = GetFocus()->GetDlgCtrlID();
  switch (nID)
  {
    case IDC_CID: // Card ID setzen
      OnCardId();
      break;

    case IDC_TCL_SEND: // T=CL Kommando senden
      OnCommonRequest();
      break;
  }
}

void CDesfireTestDlg::OnCancel() 
{
  if (IsDlgButtonChecked(IDC_UID_ZYKLISCH))
    return;

	CDialog::OnCancel();
}

void CDesfireTestDlg::OnCardId() 
{
	if (!UpdateData(TRUE))
    return;

  if (TSHRW_ISO14443SetCID(m_hPort,m_CID) != TSHRW_RETVAL_OK)
    ShowMessage("ISO14443 SetCID Error",TSHRW_GetLastError(m_hPort));
  else
    ShowMessage("");
}

void CDesfireTestDlg::OnRats() 
{
  BYTE ATS[20];
  int  ATSLen;
	if (!UpdateData(TRUE))
    return;

  ATSLen = TSHRW_ISO14443Rats(m_hPort,ATS,sizeof(ATS));
  if (ATSLen < 0)
  {
    ShowMessage("ISO14443 Rats Error",TSHRW_GetLastError(m_hPort));
  }
  else
  {
    Hex2String(m_ATS,ATS,ATSLen);
    UpdateData(FALSE);
    ShowMessage("");
  }
}

void CDesfireTestDlg::OnPPS() 
{
	if (!UpdateData(TRUE))
    return;

  // Speed wird fr beide Richtungen gleich angegeben.

  if (TSHRW_ISO14443PPS(m_hPort,m_DRI|(m_DSI<<2)) < 0)
  {
    ShowMessage("ISO14443 PPS Error",TSHRW_GetLastError(m_hPort));
  }
  else
  {
    ShowMessage("");
  }
}

CString MakeTCLErrorCode(BYTE Code)
{
  switch (Code)
  {
    case 0x00: return "Successful operation";
    case 0x0C: return "No changes done";
    case 0x0E: return "Insufficient NV-Memory to complete operation";
    case 0x1C: return "Command code not supported";
    case 0x1E: return "Integrity error";
    case 0x40: return "Invalid Key number specified";
    case 0x7E: return "Length of Command string invalid";
    case 0x9D: return "Current config/status does not allow the requested command";
    case 0x9E: return "Value of the parameter invalid";
    case 0xA0: return "Requested AID not present on PICC";
    case 0xA1: return "Unrecoverable error withing application";
    case 0xAE: return "Current Authentication status does not allowt the requested command";
    case 0xAF: return "Additonal data frame is expected to be sent";
    case 0xBE: return "Attempt to read/write data from/to beyond the file's limits";
    case 0xC1: return "Unrecoverable error in PICC";
    case 0xCA: return "Previous command was not fulle completed";
    case 0xCD: return "PICC was disabledby an Unrecoverable error";
    case 0xCE: return "Max. number of applications reached";
    case 0xDE: return "Duplicate file number given";
    case 0xEE: return "EEProm could not be written";
    case 0xF0: return "File not found";
    case 0xF1: return "Unrecoverable error in file";
  }
  return "Unknown error " + Byte2String(Code);
}

CString MakeT1ErrorCode(BYTE SW1, BYTE SW2)
{
  switch (MAKEWORD(SW1,SW2))
  {
    case MAKEWORD(0x64,0x00): return "EEPROM busy";
    case MAKEWORD(0x64,0x01): return "RC222 interface error";
    case MAKEWORD(0x65,0x02): return "SAM key reference number invalid";
    case MAKEWORD(0x65,0x03): return "SAM key usage counter number invalid";
    case MAKEWORD(0x65,0x81): return "EEPROM high voltage failure";
    case MAKEWORD(0x67,0x00): return "Wrong length of the APDU or wrong Lc Byte";
    case MAKEWORD(0x68,0x83): return "final chained command expected";
    case MAKEWORD(0x69,0x84): return "CRC mismatch; wrong key handling buffer size";
    case MAKEWORD(0x6A,0x86): return "Incorrect value for parameter P1 and/or P2";
    case MAKEWORD(0x6C,0x00): return "Incorrect Le value";
    case MAKEWORD(0x6D,0x00): return "Instruction code not supported or invalid";
    case MAKEWORD(0x6E,0x00): return "Class not supported";
    case MAKEWORD(0x6F,0x00): return "No precise diagnosis";
    case MAKEWORD(0x90,0x00): return "Correct execution";

    case MAKEWORD(0x90,0xAF): return "Additonal data frame is expected to be sent";
    case MAKEWORD(0x90,0xBE): return "Mifare PICC send incorrect amoiunt of data";
    case MAKEWORD(0x90,0xBF): return "Mifare PICC returned error";
    case MAKEWORD(0x90,0xE0): return "no response from card";
    case MAKEWORD(0x90,0xE1): return "ISO 14443 protocol error";
    case MAKEWORD(0x90,0xE2): return "Parity error";
    case MAKEWORD(0x90,0xE3): return "Buffer overflow";
    case MAKEWORD(0x90,0xE4): return "(N)ACK expected, CRC mismatch";
    case MAKEWORD(0x90,0xE5): return "RF field inactive";
    case MAKEWORD(0x90,0xE6): return "Temperature error";
    case MAKEWORD(0x90,0xE7): return "FIFO write error";
    case MAKEWORD(0x90,0xE8): return "Collision error";
    case MAKEWORD(0x90,0xE9): return "internal transaction buffer overflow";
    case MAKEWORD(0x90,0xEA): return "UID check byte (BCC) incorrect";
    case MAKEWORD(0x90,0xEB): return "incorrect block number";
    case MAKEWORD(0x90,0xEC): return "ATS length byte does not match actual length of received ATS";
    case MAKEWORD(0x90,0xED): return "User buffer length below minimum";

    case MAKEWORD(0x90,0xF0): return "Mifare PICC sent NACK 0";
    case MAKEWORD(0x90,0xF1): return "Mifare PICC sent NACK 1";
    case MAKEWORD(0x90,0xF2): return "Mifare PICC sent NACK 2";
    case MAKEWORD(0x90,0xF3): return "Mifare PICC sent NACK 3";
    case MAKEWORD(0x90,0xF4): return "Mifare PICC sent NACK 4";
    case MAKEWORD(0x90,0xF5): return "Mifare PICC sent NACK 5";
    case MAKEWORD(0x90,0xF6): return "Mifare PICC sent NACK 6";
    case MAKEWORD(0x90,0xF7): return "Mifare PICC sent NACK 7";
    case MAKEWORD(0x90,0xF8): return "Mifare PICC sent NACK 8";
    case MAKEWORD(0x90,0xF9): return "Mifare PICC sent NACK 9";
    case MAKEWORD(0x90,0xFA): return "Mifare PICC sent NACK A";
    case MAKEWORD(0x90,0xFB): return "Mifare PICC sent NACK B";
    case MAKEWORD(0x90,0xFC): return "Mifare PICC sent NACK C";
    case MAKEWORD(0x90,0xFD): return "Mifare PICC sent NACK D";
    case MAKEWORD(0x90,0xFE): return "Mifare PICC sent NACK E";
    case MAKEWORD(0x90,0xFF): return "Mifare PICC sent NACK F";
  }
  return "Unknown error " + Byte2String(SW1) + " " + Byte2String(SW2);
}

void CDesfireTestDlg::OnCommonRequest() 
{
  BYTE SendBuffer[50];
  BYTE RecvBuffer[50];
  int SendLen;
  int RecvLen;

	if (!UpdateData(TRUE))
    return;

	if (!m_hPort)
    return;

  SendLen = String2Hex(SendBuffer,16,m_TCLSend);

  if (SendLen < 1)
  {
    AfxMessageBox("Daten zu kurz",MB_ICONINFORMATION|MB_OK);
    return;
  }

  RecvLen = TSHRW_ISO14443Transmit(m_hPort,SendBuffer,SendLen,RecvBuffer,sizeof(RecvBuffer));

  if (RecvLen < 0)
  {
    ShowMessage("ISO14443 Transmit Error",TSHRW_GetLastError(m_hPort));
  }
  else
  {
    Hex2String(m_TCLReceive,RecvBuffer,RecvLen);
    if (RecvLen > 0)
    {
      ShowMessage(MakeTCLErrorCode(RecvBuffer[0]));
    }

    UpdateData(FALSE);
  }
}
