// BlockDlg.cpp : Implementation file
//

#include "stdafx.h"
#include "Block.h"
#include "BlockDlg.h"
#include "TS_HRW_Import.h"

#include "label.h"
#include "BitmapStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib, "version.lib")

CString GetProgVersion ()
{
  char * abData;
  char String[255];
  CString Version;
  DWORD  handle = NULL;
  UINT   wSize = 0;
  DWORD  dwMax = 0;
  LPSTR  lpBuffer = NULL;
  char ExeName[_MAX_PATH];
  ::GetModuleFileName(NULL,ExeName,_MAX_PATH);
  dwMax = GetFileVersionInfoSize(ExeName, &handle);
  if (dwMax == 0)
  {
    Version = "1.xx";
    return Version;
  }
  if (dwMax > 32000)
  {
    Version = "1.xx";
    return Version;
  }
  
  abData = new char[dwMax+10];
  memset (abData,0,(WORD)(dwMax+10));
  if (GetFileVersionInfo(ExeName, handle, dwMax, abData))
  {
    strcpy_s (String,"\\StringFileInfo\\040704b0\\ProductVersion");
    if (VerQueryValue(abData, String, (LPVOID *)&lpBuffer, &wSize))
    {
      if ((lpBuffer) && (wSize!=0) && (strlen(lpBuffer) < 20))
        Version = lpBuffer;
    }
  }
  if (Version.IsEmpty())
    Version = "1.xx";
  delete []abData;
  return Version;
}

bool IsProgrammer(BYTE Version[])
{
  // If lowest Bit in third Byte is set, it is a Programmer
  return (Version[2] & 0x01)?true:false;
}

CString MakeHexString(BYTE * pData, int Len)
{
  CString Line;
  CString Item;

  for (int i = 0; i < Len; i++)
  {
    Item.Format("%02X ", pData[i]);
    Line += Item;
  }
  Line.TrimRight();
  return Line;
}

void FromHexString(BYTE * pData, CString Line, int Len)
{
  CString Item;

  // Strip all Blank Space characters
  Line.Remove(' ');

  for (int i = 0; i < Len; i++)
  {
    if (Line.GetLength() >= 2)
    {
      Item = Line.Left(2);
      Line = Line.Mid(2);
      pData[i] = (BYTE)strtol(Item, NULL, 16);
    }
    else
    {
      pData[i] = 0;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialog box for "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CBitmapStatic	m_GisBitmap;
  CLabel m_Email;
  CLabel m_URL;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_GIS_LOGO, m_GisBitmap);
	DDX_Control(pDX, IDC_EMAIL, m_Email);
	DDX_Control(pDX, IDC_URL, m_URL);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

  // URL und Email als Link darstellen (Blau, unterstrichen)
  LOGFONT lf;
  GetFont()->GetLogFont(&lf);
  lf.lfUnderline = TRUE;
  m_Email.SetFont(&lf);
  m_Email.SetLink(TRUE);
  m_Email.SetTextColor(RGB(  0,  0,255));
  m_Email.SetLinkCursor(::LoadCursor(NULL,MAKEINTRESOURCE(32649)));
  m_URL  .SetFont(&lf);
  m_URL  .SetLink(TRUE);
  m_URL  .SetTextColor(RGB(  0,  0,255));
  m_URL  .SetLinkCursor(::LoadCursor(NULL,MAKEINTRESOURCE(32649)));

  m_GisBitmap.SetTransparent();

  // show correct version information
  CString text;
  GetDlgItemText(IDC_VERSION,text);
  
  text += " ";
  text += GetProgVersion();
  SetDlgItemText (IDC_VERSION,text);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/////////////////////////////////////////////////////////////////////////////
// CBlockDlg Dialogfeld

CBlockDlg::CBlockDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBlockDlg::IDD, pParent)
  , m_nBlockNr(0)
  , m_strUID(_T(""))
{
	//{{AFX_DATA_INIT(CBlockDlg)
	m_BlockData = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_nPortHandle = NULL;
  m_nError = 0;
}

void CBlockDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);

  //{{AFX_DATA_MAP(CBlockDlg)
  DDX_Text(pDX, IDC_BLOCK_DATA, m_BlockData);
  //}}AFX_DATA_MAP
  DDX_Text(pDX, IDC_BLOCK_NR, m_nBlockNr);
  DDV_MinMaxInt(pDX, m_nBlockNr, 0, 255);
  DDX_Text(pDX, IDC_UID, m_strUID);
}

BEGIN_MESSAGE_MAP(CBlockDlg, CDialog)
	//{{AFX_MSG_MAP(CBlockDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_READ_BLOCK, OnReadBlock)
	ON_BN_CLICKED(IDC_WRITE_BLOCK, OnWriteBlock)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBlockDlg Message-Handler

BOOL CBlockDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// for big Symbol
	SetIcon(m_hIcon, FALSE);		// for small Symbol
	
  // Get List of all USB Devices
  int nMaxSize = 255;
	char USBNamesBuffer[255];
  CStringList USBListe;
  CString strName;
	int nLen = TSHRW_ListAllDeviceNames(USBNamesBuffer,nMaxSize);
  int nStrLen = 0;
  do
  {
    strName = USBNamesBuffer + nStrLen;
    nStrLen += strName.GetLength() + 1;
    if(strName.GetLength() != 0)
      USBListe.AddTail(strName);
  }while(strName.GetLength() != 0);

	// Use first USB device and open port
  // the port has to be closed when application closes
  // This is done in OnDestroy() .
  // If no USB-Device is found, the application tries to open a COM Port.
  m_nPortHandle = -1;
  if(USBListe.GetCount() > 0)
  {
    m_nPortHandle = TSHRW_OpenPort(USBListe.GetHead(),19200,1000);
    if (m_nPortHandle > 0)
    {
      // Get device version from device, to check if read device is connected.
      // The first 3 digits of the string give the device number
      // valid device number is 039 for TS-W34AC
      BYTE Version[4];
      int nReturn = TSHRW_DeviceVersion(m_nPortHandle, Version, 4);
      if(nReturn == -1)
      {
        int Error = TSHRW_GetLastError(m_nPortHandle);
        TSHRW_ClosePort(m_nPortHandle);
        m_nPortHandle = -1;
      }
      else
      {
        if (IsProgrammer(Version))
        {
          // Device is valid
        }
        else
        {
          // Invalid device, will be closed
          AfxMessageBox("Connected device is no programmer! Please use a programmer instead");
          TSHRW_ClosePort(m_nPortHandle);
          m_nPortHandle = -1;
        }
      }
    }
  }
  else
  {
    // Try connection using a COM port
    CString com = "COM1";
    int nMaxSize = 255;
    // First get list of com ports
	  char * COMNamesBuffer = new char[nMaxSize];
    CStringList COMListe;
    CString strName;
	  int nLen = TSHRW_GetAvailablePorts(COMNamesBuffer,nMaxSize);
    int nStrLen = 0;
    do
    {
      strName = COMNamesBuffer + nStrLen;
      nStrLen += strName.GetLength() + 1;
      if(strName.GetLength() != 0)
        COMListe.AddTail(strName);
    }while(strName.GetLength() != 0);
    delete COMNamesBuffer;

    // then try all found ports
    POSITION Pos = COMListe.GetHeadPosition();
    while (Pos)
    {
      m_nPortHandle = TSHRW_OpenPort(COMListe.GetNext(Pos),19200,1000);
      if (m_nPortHandle > 0)
      {
        // Get device version from device, to cehck if read device is connected.
        // The first 3 digits of the string give the device number
        // valid device number is 039 for TS-W34AC
        BYTE Version[4];
        int nReturn = TSHRW_DeviceVersion(m_nPortHandle, Version, 4);
        if(nReturn == -1)
        {
          int Error = TSHRW_GetLastError(m_nPortHandle);
          TSHRW_ClosePort(m_nPortHandle);
          m_nPortHandle = -1;
        }
        else
        {
          if (IsProgrammer(Version))
          {
            // Device is valid
          }
          else
          {
            // Invalid device, will be closed
            AfxMessageBox("Connected device is no programmer! Please use a programmer instead");
            TSHRW_ClosePort(m_nPortHandle);
            m_nPortHandle = -1;
          }
          break;
        }
      }
    }
  }

  if (m_nPortHandle <= 0)
    AfxMessageBox("No connection to device");
	return TRUE;  
}

void CBlockDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CBlockDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CBlockDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBlockDlg::OnDestroy()
{
  // Close Port if open
  if(m_nPortHandle)
  {
    TSHRW_ClosePort(m_nPortHandle);
    m_nPortHandle = 0;
  }

	CDialog::OnDestroy();
}

BYTE MakeHex(CString str)
{
  return (BYTE)strtol(str,NULL,16);
}

bool CBlockDlg::Select()
{
  BYTE UIDBuff[10];
  WORD ATQA;
  BYTE SAK;
  int  UIDLen;

  m_UID = 0;
  m_strUID.Empty();

  if (TSHRW_Mifare_Request(m_nPortHandle, &ATQA) == -1)
  {
    CString strMsg;
    strMsg.Format("Error %d at Mifare Request", TSHRW_GetLastError(m_nPortHandle));
    AfxMessageBox(strMsg);
    return false;
  }

  UIDLen = TSHRW_Mifare_Select(m_nPortHandle, UIDBuff, 10,&SAK);
  if (UIDLen < 4)
  {
    CString strMsg;
    strMsg.Format("Error %d at Mifare Select", TSHRW_GetLastError(m_nPortHandle));
    AfxMessageBox(strMsg);
    return false;
  }

  m_UID = *(__int64*)UIDBuff;
  if (UIDLen == 4)
  {
    m_UID &= 0x00000000FFFFFFFFI64;
    m_strUID.Format("%08I64X", m_UID);
  }
  else if (UIDLen == 7)
  {
    m_UID &= 0x00FFFFFFFFFFFFFFI64;
    m_strUID.Format("%14I64X", m_UID);
  }

  if ((SAK == 0x08) || (SAK == 0x88))
  {
    // Mifare 1K
    if (Authenticate())
      return true;
  }
  else if (SAK == 0x18)
  {
    // Mifare 4K
    if (Authenticate())
      return true;
  }
  else if (SAK == 0x00)
  {
    // Mifare Ultralight
    return true;
  }
  else
  {
    // Other Chip, not supported by ths application
    CString strMsg;
    strMsg.Format("Unsupported chip type");
    AfxMessageBox(strMsg);
    return false;
  }

  return false;
}

BYTE DefaultKeyANXP[] = { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF };

bool CBlockDlg::Authenticate()
{
  BYTE Key[6];
  int  KeyType;

  memcpy(Key, DefaultKeyANXP, sizeof(DefaultKeyANXP));
  KeyType = MIFARE_AUTH_A;

  if (TSHRW_MifareAuthenticateDirect(m_nPortHandle, NULL, 0, KeyType, Key, 6, m_nBlockNr) == TSHRW_RETVAL_OK)
  {
    return true;
  }
  return false;
}

void CBlockDlg::OnReadBlock()
{
  if (m_nPortHandle <= 0)
  {
    AfxMessageBox("No Device open");
    return;
  }

  UpdateData(TRUE);

  m_BlockData.Empty();

  if (!Select())
  {
    UpdateData(FALSE);
    return;
  }

  BYTE BlockData[16];
  int DataLen;
  memset(BlockData, 0, 16);

  DataLen = TSHRW_MifareRead(m_nPortHandle, m_nBlockNr, BlockData, 16);
  if (DataLen != -1)
  {
    // Read successfully done
    m_BlockData = MakeHexString(BlockData,DataLen);
  }
  else
  {
    CString strMsg;
    strMsg.Format("Error %d reading Block data",TSHRW_GetLastError(m_nPortHandle));
    AfxMessageBox(strMsg);
  }

  UpdateData(FALSE);
}

void CBlockDlg::OnWriteBlock()
{
  if (m_nPortHandle <= 0)
  {
    AfxMessageBox("No Device open");
    return;
  }

  UpdateData(TRUE);

  if (!Select())
  {
    UpdateData(FALSE);
    return;
  }

  // Get Block Code from Editbox
  // It is used as hexadecimal coding here
  BYTE BlockData[16];
  FromHexString(BlockData, m_BlockData, 16);

  if (TSHRW_MifareWrite(m_nPortHandle, m_nBlockNr, BlockData, 16) != -1)
  {
    CString strMsg;
    strMsg.Format("Block data written to Transponder");
    AfxMessageBox(strMsg);
  }
  else
  {
    CString strMsg;
    strMsg.Format("Error %d writing Block Data",TSHRW_GetLastError(m_nPortHandle));
    AfxMessageBox(strMsg);
  }

  UpdateData(FALSE);
}
